install 46 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238123912401241124212431244124512461247124812491250125112521253125412551256125712581259126012611262126312641265126612671268126912701271127212731274127512761277127812791280128112821283128412851286128712881289129012911292129312941295129612971298129913001301130213031304130513061307130813091310131113121313131413151316131713181319132013211322132313241325132613271328132913301331133213331334133513361337133813391340134113421343134413451346134713481349135013511352135313541355135613571358135913601361136213631364136513661367136813691370137113721373137413751376137713781379138013811382138313841385138613871388138913901391139213931394139513961397139813991400140114021403140414051406140714081409141014111412141314141415141614171418141914201421142214231424142514261427142814291430143114321433143414351436143714381439144014411442144314441445144614471448144914501451145214531454145514561457145814591460
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios & Firewall
  21. type="ERROR"
  22. exitNum=$1
  23. shift
  24. codeNum=$1
  25. shift
  26. extraInfo=$@
  27. case $codeNum in
  28. 1)
  29. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  30. ;;
  31. 2)
  32. error="$type $codeNum:\tError interno (selección express).\n"
  33. ;;
  34. 3)
  35. error="$type $codeNum:\tError interno (selección avanzada).\n"
  36. ;;
  37. 4)
  38. error="\n$type $codeNum:\tEl archivo '"$(realpath $extraInfo)"' no existe.\n"
  39. ;;
  40. 5)
  41. error="\n$type $codeNum:\tEl directorio '"$(realpath $extraInfo)"' no existe.\n"
  42. ;;
  43. 6)
  44. error="$type $codeNum:\tError interno (selección SSL/TLS).\n"
  45. ;;
  46. 100)
  47. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  48. ;;
  49. 101)
  50. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  51. ;;
  52. 102)
  53. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  54. ;;
  55. 103)
  56. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  57. ;;
  58. 104)
  59. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  60. ;;
  61. 105)
  62. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  63. ;;
  64. 106)
  65. type="WARNING"
  66. error="\n$type $codeNum:\tImposible instalar 'info.php'.\n"
  67. ;;
  68. 107)
  69. error="\n$type $codeNum:\tError al configurar Nginx.\n"
  70. ;;
  71. 108)
  72. error="\n$type $codeNum:\tError al configurar Apache2.\n"
  73. ;;
  74. 200)
  75. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  76. ;;
  77. 201)
  78. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  79. ;;
  80. 202)
  81. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  82. ;;
  83. 203)
  84. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  85. ;;
  86. 204)
  87. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  88. ;;
  89. 205)
  90. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  91. ;;
  92. 206)
  93. type="WARNING"
  94. error="\n$type $codeNum:\tUsuario 'root' ya dispone de contraseña."
  95. ;;
  96. 207)
  97. error="\n$type $codeNum:\tImposible cambiar la contraseña de 'root'."
  98. ;;
  99. 208)
  100. error="\n$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior."
  101. ;;
  102. 209)
  103. error="\n$type $codeNum:\tImposible eliminar usuarios anónimos."
  104. ;;
  105. 210)
  106. type="WARNING"
  107. error="\n$type $codeNum:\tImposible eliminar bases de datos de pruebas."
  108. ;;
  109. 211)
  110. type="WARNING"
  111. error="\n$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas."
  112. ;;
  113. 212)
  114. error="\n$type $codeNum:\tImposible recargar base de datos."
  115. ;;
  116. 300)
  117. error="\n$type $codeNum:\tError interno (instalación PHP-7.2).\n"
  118. ;;
  119. 301)
  120. error="\n$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  121. ;;
  122. 302)
  123. error="\n$type $codeNum:\tError al instalar PHP-7.2.\nDetalles:\n$extraInfo\n"
  124. ;;
  125. 303)
  126. error="\n$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  127. ;;
  128. 304)
  129. error="\n$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  130. ;;
  131. 305)
  132. error="\n$type $codeNum:\tImposible configurar PHP-7.2.\n"
  133. ;;
  134. 501)
  135. error="\n$type $codeNum:\tImposible descargar MediaWiki-1.31.0.\n"
  136. ;;
  137. 502)
  138. error="\n$type $codeNum:\tImposible configurar MediaWiki-1.31.0.\n"
  139. ;;
  140. 503)
  141. error="\n$type $codeNum:\tImposible configurar Base de Datos para MediaWiki-1.31.0.\n"
  142. ;;
  143. 601)
  144. error="\n$type $codeNum:\tImposible descargar Moodle-3.5.1.\n"
  145. ;;
  146. 800)
  147. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  148. ;;
  149. 801)
  150. error="$type $codeNum:\t'whiptail' no instalado.\n"
  151. ;;
  152. 802)
  153. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  154. ;;
  155. 803)
  156. error="$type $codeNum:\t'apt-get' no instalado.\n"
  157. ;;
  158. 804)
  159. error="$type $codeNum:\t'yum' no instalado.\n"
  160. ;;
  161. 805)
  162. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  163. ;;
  164. 806)
  165. error="$type $codeNum:\t'ufw' no instalado.\n"
  166. ;;
  167. 807)
  168. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  169. ;;
  170. 808)
  171. error="$type $codeNum:\t'tput' no instalado.\nDetalles:\n$extraInfo\n"
  172. ;;
  173. 809)
  174. error="$type $codeNum:\t'sed' no instalado.\nDetalles:\n$extraInfo\n"
  175. ;;
  176. 810)
  177. error="$type $codeNum:\t'curl' no instalado.\nDetalles:\n$extraInfo\n"
  178. ;;
  179. 811)
  180. error="$type $codeNum:\t'tar' no instalado.\nDetalles:\n$extraInfo\n"
  181. ;;
  182. 812)
  183. error="$type $codeNum:\t'gzip' no instalado.\nDetalles:\n$extraInfo\n"
  184. ;;
  185. 813)
  186. error="$type $codeNum:\t'bzip2' no instalado.\nDetalles:\n$extraInfo\n"
  187. ;;
  188. 814)
  189. error="$type $codeNum:\t'xz' no instalado.\nDetalles:\n$extraInfo\n"
  190. ;;
  191. 815)
  192. error="$type $codeNum:\t'openssl' no instalado.\nDetalles:\n$extraInfo\n"
  193. ;;
  194. 816)
  195. error="$type $codeNum:\t'find' no instalado.\n"
  196. ;;
  197. 900)
  198. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  199. ;;
  200. 901)
  201. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  202. ;;
  203. 902)
  204. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  205. ;;
  206. 903)
  207. error="$type $codeNum:\tError interno (deshabilitar servicio).\n"
  208. ;;
  209. 904)
  210. error="$type $codeNum:\tImposible parar servicio '$extraInfo'.\n"
  211. ;;
  212. 905)
  213. error="$type $codeNum:\tImposible deshabilitar servicio '$extraInfo' durante el arranque.\n"
  214. ;;
  215. 906)
  216. type="WARNING"
  217. error="\n$type $codeNum:\tImposible añadir regla al cortafuegos ('$extraInfo').\n"
  218. ;;
  219. 907)
  220. type="WARNING"
  221. error="\n$type $codeNum:\tImposible encender cortafuegos.\n"
  222. ;;
  223. 908)
  224. error="\n$type $codeNum:\tError interno (instalar Virtual Host).\n"
  225. ;;
  226. 909)
  227. error="\n$type $codeNum:\tVirtual Host '$extraInfo' no existe.\n"
  228. ;;
  229. 910)
  230. error="\n$type $codeNum:\tImposible copiar Virtual Host '$extraInfo'.\n"
  231. ;;
  232. 911)
  233. error="\n$type $codeNum:\tImposible activar Virtual Host '$extraInfo'.\n"
  234. ;;
  235. 912)
  236. error="\n$type $codeNum:\tError interno (recargar servicio).\n"
  237. ;;
  238. 913)
  239. error="\n$type $codeNum:\tImposible recargar servicio '$extraInfo'.\n"
  240. ;;
  241. *)
  242. error="ERROR 13:\tError interno (comprobación de errores)\n"
  243. exitNum=1
  244. codeNum=13
  245. ;;
  246. esac
  247. if [ $exitNum -ne 0 ];then
  248. echo -en "$error" | tee -a $logFile
  249. if [ $type = "ERROR" ];then
  250. exit $codeNum
  251. fi
  252. fi
  253. unset error exitNum codeNum type
  254. }
  255. OSInfo() {
  256. echo -en "Detectando SO..." >> $logFile
  257. OS=$(uname -s)
  258. if [ $OS = "Linux" ]; then
  259. OS="GNU/Linux"
  260. if [ -f /etc/os-release ]; then
  261. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  262. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  263. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  264. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  265. for i in $ID_LIKE; do
  266. #echo -en "$i\n"
  267. case $i in
  268. debian|ubuntu)
  269. debianOS=true
  270. break
  271. ;;
  272. rhel|fedora)
  273. rhelOS=true
  274. break
  275. ;;
  276. *)
  277. debianOS=false
  278. rhelOS=false
  279. ;;
  280. esac
  281. done
  282. elif [ -f /etc/debian-version ]; then
  283. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  284. DIST="Debian"
  285. REV=""
  286. ID_LIKE="debian"
  287. VERSION=""
  288. debianOS=true
  289. elif [ -f /etc/redhat-release ]; then
  290. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  291. DIST="Red-Hat"
  292. REV=""
  293. ID_LIKE="rhel"
  294. VERSION=""
  295. rhelOS=true
  296. else
  297. # Other Linux (No Soportado)
  298. DIST=""
  299. REV=""
  300. ID_LIKE=""
  301. VERSION=""
  302. fi
  303. else
  304. # UNIX, OS X, ... (No Soportado)
  305. DIST=$OS
  306. REV=""
  307. ID_LIKE=""
  308. VERSION=""
  309. fi
  310. echo -en " $OS $DIST $REV\n" >> $logFile
  311. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  312. echo -en "$HDInfo\n" >> $logFile
  313. }
  314. comprobarRoot() {
  315. comprobarError $(id -u) 800
  316. }
  317. comprobarDependencias() {
  318. # Comprobamos whiptail
  319. which whiptail > /dev/null 2>&1
  320. comprobarError $? 801
  321. # Comprobamos hostnamectl
  322. which hostnamectl > /dev/null 2>&1
  323. comprobarError $? 802
  324. which find > /dev/null 2>&1
  325. comprobarError $? 816
  326. if [ $debianOS = true ];then
  327. # Comprobamos apt-get
  328. which apt-get > /dev/null 2>&1
  329. comprobarError $? 803
  330. # Actualizamos base de datos del repositorio
  331. echo -en "Actualizando repositorio APT..." | tee -a $logFile
  332. result=$(apt-get -q -y update 2>&1)
  333. comprobarError $? 805 $result
  334. echo -en " OK.\n" | tee -a $logFile
  335. # Comprobamos Firewall (ufw)
  336. which ufw > /dev/null 2>&1
  337. comprobarError $? 806
  338. # Comprobamos tput
  339. which tput > /dev/null 2>&1
  340. if [ $? -ne 0 ];then
  341. result=$(apt-get -q -y ncurses-bin 2>&1)
  342. comprobarError $? 808 $result
  343. fi
  344. # Comprobar sed
  345. which sed > /dev/null 2>&1
  346. if [ $? -ne 0 ];then
  347. result=$(apt-get -q -y sed 2>&1)
  348. comprobarError $? 809 $result
  349. fi
  350. # Comprobar curl
  351. which curl > /dev/null 2>&1
  352. if [ $? -ne 0 ];then
  353. result=$(apt-get -q -y curl 2>&1)
  354. comprobarError $? 810 $result
  355. fi
  356. # Comprobamos tar, gzip, bzip2 y xz
  357. which tar > /dev/null 2>&1
  358. if [ $? -ne 0 ];then
  359. result=$(apt-get -q -y install tar 2>&1)
  360. comprobarError $? 811 $result
  361. fi
  362. which gzip > /dev/null 2>&1
  363. if [ $? -ne 0 ];then
  364. result=$(apt-get -q -y install gzip 2>&1)
  365. comprobarError $? 812 $result
  366. fi
  367. which bzip2 > /dev/null 2>&1
  368. if [ $? -ne 0 ];then
  369. result=$(apt-get -q -y install bzip2 2>&1)
  370. comprobarError $? 813 $result
  371. fi
  372. which xz > /dev/null 2>&1
  373. if [ $? -ne 0 ];then
  374. result=$(apt-get -q -y install xz-utils 2>&1)
  375. comprobarError $? 814 $result
  376. fi
  377. which openssl > /dev/null 2>&1
  378. if [ $? -ne 0 ];then
  379. result=$(apt-get -q -y install openssl 2>&1)
  380. comprobarError $? 815 $result
  381. fi
  382. fi
  383. if [ $rhelOS = true ]; then
  384. # Comprobamos yum
  385. which yum > /dev/null 2>&1
  386. comprobarError $? 804
  387. # Actualizamos base de datos del repositorio
  388. echo -en "Actualizando repositorio YUM..." | tee -a $logFile
  389. result=$(yum -y makecache 2>&1)
  390. comprobarError $? 805 $result
  391. echo -en " OK.\n" | tee -a $logFile
  392. # Comprobamos Firewall (firewall-cmd)
  393. which firewall-cmd > /dev/null 2>&1
  394. comprobarError $? 807
  395. # Comprobamos tput
  396. which tput > /dev/null 2>&1
  397. if [ $? -ne 0 ];then
  398. result=$(yum -y ncurses 2>&1)
  399. comprobarError $? 808 $result
  400. fi
  401. # Comprobar sed
  402. which sed > /dev/null 2>&1
  403. if [ $? -ne 0 ];then
  404. result=$(yum -y sed 2>&1)
  405. comprobarError $? 809 $result
  406. fi
  407. # Comprobar curl
  408. which curl > /dev/null 2>&1
  409. if [ $? -ne 0 ];then
  410. result=$(yum -y curl 2>&1)
  411. comprobarError $? 810 $result
  412. fi
  413. # Comprobamos tar, gzip, bzip2 y xz
  414. which tar > /dev/null 2>&1
  415. if [ $? -ne 0 ];then
  416. result=$(yum -y install tar 2>&1)
  417. comprobarError $? 811 $result
  418. fi
  419. which gzip > /dev/null 2>&1
  420. if [ $? -ne 0 ];then
  421. result=$(yum -y install gzip 2>&1)
  422. comprobarError $? 812 $result
  423. fi
  424. which bzip2 > /dev/null 2>&1
  425. if [ $? -ne 0 ];then
  426. result=$(yum -y install bzip2 2>&1)
  427. comprobarError $? 813 $result
  428. fi
  429. which xz > /dev/null 2>&1
  430. if [ $? -ne 0 ];then
  431. result=$(yum -y install xz 2>&1)
  432. comprobarError $? 814 $result
  433. fi
  434. which openssl > /dev/null 2>&1
  435. if [ $? -ne 0 ];then
  436. result=$(yum -y install openssl 2>&1)
  437. comprobarError $? 815 $result
  438. fi
  439. fi
  440. }
  441. inicializarVariables() {
  442. debianOS=false
  443. rhelOS=false
  444. apacheOn=false
  445. nginxOn=false
  446. mySQLOn=false
  447. mariaDBOn=false
  448. phpOn=false
  449. sslOn=false
  450. letsEncryptOn=false
  451. mediaWikiOn=false
  452. moodleOn=false
  453. infoPHPOn=false
  454. actualizacionesOn=false
  455. progreso=0
  456. progresoTotal=0
  457. hostname=""
  458. logFile="./."$(basename $0)".log"
  459. maxUpload="100M"
  460. webServerName=""
  461. webServerUser=""
  462. webServerGroup=""
  463. sqlServerName=""
  464. phpFPMName=""
  465. dominioMediaWiki=""
  466. }
  467. instalacionExpress() {
  468. apacheOn=true
  469. mariaDBOn=true
  470. phpOn=true
  471. sslOn=true
  472. letsEncryptOn=true
  473. mediaWikiOn=true
  474. moodleOn=true
  475. actualizacionesOn=true
  476. progresoTotal=15
  477. # Preguntas mínimas
  478. establecerFQDN
  479. leerSQLPasswd
  480. }
  481. mostrarBienvenida() {
  482. ANCHO=$(tput cols)
  483. ALTO=$(tput lines)
  484. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  485. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  486. exit 1
  487. fi
  488. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  489. comprobarError $? 1
  490. }
  491. mostrarExpress() {
  492. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  493. "Express" "Instalación rápida" ON \
  494. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  495. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  496. comprobarError $? 1
  497. case $express in
  498. Express)
  499. instalacionExpress
  500. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  501. ;;
  502. Avanzada)
  503. mostrarAvanzada
  504. ;;
  505. *)
  506. comprobarError 1 2
  507. ;;
  508. esac
  509. unset express
  510. }
  511. mostrarAvanzada() {
  512. webServer=$(whiptail --title "INSTALACION AVANZADA" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Servidor Web que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  513. "LAMP" "GNU/Linux + Apache + MySQL/MariaDB + PHP-7" ON \
  514. "LEMP" "GNU/Linux + Nginx + MySQL/MariaDB + PHP-7" OFF \
  515. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  516. comprobarError $? 1
  517. for i in $webServer; do
  518. case $i in
  519. LAMP)
  520. apacheOn=true
  521. ;;
  522. LEMP)
  523. nginxOn=true
  524. ;;
  525. *)
  526. comprobarError 1 100
  527. ;;
  528. esac
  529. done
  530. # Opciones comunes
  531. establecerFQDN
  532. mostrarDatabase
  533. phpOn=true
  534. establecerMaxUpload
  535. progresoTotal=$((progresoTotal + 6))
  536. mostrarComponentes
  537. unset webServer
  538. }
  539. mostrarComponentes() {
  540. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 5 \
  541. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  542. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  543. "Moodle" "Instalar campus virtual con Moodle" ON \
  544. "InfoPHP" "Instalar info.php (sólo para pruebas)" OFF \
  545. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  546. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  547. comprobarError $? 1
  548. # Mejora: autodetección de componentes ya instalados
  549. for i in $componentes; do
  550. case $i in
  551. \"SSL/TLS\")
  552. # 2 Opciones: Let's Encrypt o Autofirmado
  553. mostrarSSL
  554. progresoTotal=$((progresoTotal + 2))
  555. ;;
  556. \"MediaWiki\")
  557. mediaWikiOn=true
  558. mostrarMediaWiki
  559. progresoTotal=$((progresoTotal + 2))
  560. ;;
  561. \"Moodle\")
  562. moodleOn=true
  563. progresoTotal=$((progresoTotal + 2))
  564. ;;
  565. \"InfoPHP\")
  566. infoPHPOn=true
  567. progresoTotal=$((progresoTotal + 2))
  568. ;;
  569. \"Actualizaciones\")
  570. actualizacionesOn=true
  571. progresoTotal=$((progresoTotal + 1))
  572. ;;
  573. *)
  574. comprobarError 1 3
  575. ;;
  576. esac
  577. done
  578. progresoTotal=$((progresoTotal + 2))
  579. unset componentes
  580. }
  581. mostrarSSL() {
  582. ssl=$(whiptail --title "INSTALACION SSL/TLS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Certificado SSL/TLS que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  583. "LetsEncrypt" "Compatible con todos los navegadores" ON \
  584. "Auto-Firmado" "Certificados auto-firmados (sólo para pruebas)" OFF \
  585. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  586. comprobarError $? 1
  587. for i in $ssl; do
  588. case $i in
  589. LetsEncrypt)
  590. sslOn=true
  591. letsEcnryptOn=true
  592. ;;
  593. Auto-Firmados)
  594. sslOn=true
  595. ;;
  596. *)
  597. comprobarError 1 6
  598. ;;
  599. esac
  600. done
  601. unset ssl
  602. }
  603. mostrarMediaWiki(){
  604. # Introducir nombre wiki
  605. # Introducir dominio
  606. while [ -z $dominioMediaWiki ]; do
  607. dominioMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el dominio/subdominio para MediaWiki.\nTenga en cuenta que debes apuntar este a la dirección IP de esta máquina mediante un registro DNS tipo CNAME." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) wiki.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  608. comprobarError $? 1
  609. # Mejora: comprobar si el dominio ya está en uso
  610. done
  611. # Introducir tipo de Wiki (abierta, creación de cuenta requerida, sólo editores autorizados o wiki privada)
  612. }
  613. establecerFQDN() {
  614. while [ -z $hostname ]; do
  615. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  616. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  617. hostnamectl set-hostname $hostname
  618. else
  619. hostname=$(hostname)
  620. fi
  621. done
  622. echo -en "Hostname: $hostname\n" >> $logFile
  623. }
  624. instalarApache() {
  625. if [ $debianOS = true ];then
  626. webServerName="apache2"
  627. result=$(apt-get -q -y install apache2 2>&1)
  628. comprobarError $? 101 $result
  629. elif [ $rhelOS = true ]; then
  630. webServerName="httpd"
  631. result=$(yum -y install httpd 2>&1)
  632. comprobarError $? 101 $result
  633. else
  634. comprobarError 1 104
  635. fi
  636. deshabilitarServicio $webServerName
  637. }
  638. configurarApache() {
  639. if [ $debianOS = true ];then
  640. apacheConfFile="./etc/$webServerName-debian/apache2.conf"
  641. if [ ! -f $apacheConfFile ];then
  642. comprobarError 1 4 $apacheConfFile
  643. fi
  644. cp -f $apacheConfFile /etc/$webServerName/apache2.conf 2>/dev/null
  645. comprobarError $? 108
  646. webServerUser=$(grep ^User /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  647. webServerGroup=$(grep ^Group /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  648. elif [ $rhelOS = true ];then
  649. apacheConfFile="./etc/$webServerName-rhel/conf/httpd.conf"
  650. welcomeConfFile="/etc/$webServerName/conf.d/welcome.conf"
  651. if [ ! -f $apacheConfFile ];then
  652. comprobarError 1 4 $apacheConfFile
  653. fi
  654. cp -f $apacheConfFile /etc/$webServerName/conf/ 2>/dev/null
  655. comprobarError $? 108
  656. if [ -f $welcomeConfFile ];then
  657. sed -i -e 's/^/#/' $welcomeConfFile
  658. comprobarError $? 108
  659. fi
  660. webServerUser=$(grep ^User /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  661. webServerGroup=$(grep ^Group /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  662. unset apacheConfFile welcomeConfFile
  663. fi
  664. if [ ! -d "/etc/$webServerName/sites-available" ];then
  665. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  666. comprobarError $? 5 "/etc/$webServerName/sites-available"
  667. fi
  668. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  669. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  670. comprobarError $? 5 "$webServerRoot/sites-enabled"
  671. fi
  672. }
  673. instalarNginx() {
  674. webServerName="nginx"
  675. if [ $debianOS = true ];then
  676. result=$(apt-get -q -y install nginx 2>&1)
  677. comprobarError $? 102 $result
  678. elif [ $rhelOS = true ]; then
  679. # Hay que instalar primero otro repositorio
  680. result=$(yum -y install epel-release)
  681. comprobarError $? 103 $result
  682. result=$(yum -y install nginx 2>&1)
  683. comprobarError $? 102 $result
  684. else
  685. comprobarError 1 105
  686. fi
  687. deshabilitarServicio $webServerName
  688. }
  689. configurarNginx() {
  690. # Configuramos Nginx
  691. rm -Rf /etc/$webServerName/* 2>/dev/null
  692. comprobarError $? 107
  693. if [ $debianOS = true ];then
  694. nginxConfFile="./etc/$webServerName-debian"
  695. elif [ $rhelOS = true ];then
  696. nginxConfFile="./etc/$webServerName-rhel"
  697. fi
  698. if [ -d "$nginxConfFile" ];then
  699. cp -Rf $nginxConfFile/* /etc/$webServerName/ 2>/dev/null
  700. comprobarError $? 107
  701. else
  702. comprobarError 1 5 "$nginxConfFile"
  703. fi
  704. if [ ! -d "/etc/$webServerName/sites-available" ];then
  705. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  706. comprobarError $? 5 "/etc/$webServerName/sites-available"
  707. fi
  708. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  709. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  710. comprobarError $? 5 "$webServerRoot/sites-enabled"
  711. fi
  712. webServerUser=$(grep ^user /etc/$webServerName/nginx.conf | cut -d ' ' -f 2 | cut -d ';' -f 1)
  713. webServerGroup=$webServerUser
  714. unset nginxConfFile
  715. }
  716. instalarVirtualHost() {
  717. # Configuramos un Virtual Host para Apache o Nginx
  718. # Uso: instalarVirtualHost $virtualHost $virtualHostName
  719. webServerRoot=$(realpath "/etc/$webServerName/")
  720. if [ $# -eq 1 ];then
  721. virtualHost=$(realpath $1)
  722. virtualHostName=$(basename $virtualHost)
  723. elif [ $# -eq 2 ];then
  724. virtualHost=$(realpath $1)
  725. virtualHostName=$2
  726. else
  727. comprobarError 1 908
  728. fi
  729. if [ ! -f $virtualHost ];then
  730. comprobarError 1 909 $virtualHostName
  731. fi
  732. cp -f $virtualHost "$webServerRoot/sites-available/$virtualHostName" >> $logFile 2>&1
  733. comprobarError $? 910
  734. ln -s "$webServerRoot/sites-available/$virtualHostName" "$webServerRoot/sites-enabled/$virtualHostName" >> $logFile 2>&1
  735. comprobarError $? 911 $virtualHostName
  736. recargarServicio $webServerName
  737. unset webServerRoot virtualHost virtualHostName
  738. }
  739. mostrarDatabase() {
  740. if [ $debianOS = true ]; then
  741. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  742. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" ON \
  743. "MySQL" "Instalar la base de datos MySQL (uso no comercial)" OFF \
  744. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  745. comprobarError $? 1
  746. case $database in
  747. MariaDB)
  748. mariaDBOn=true
  749. ;;
  750. MySQL)
  751. mySQLOn=true
  752. ;;
  753. *)
  754. comprobarError 1 200
  755. ;;
  756. esac
  757. unset database
  758. elif [ $rhelOS = true ]; then
  759. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  760. comprobarError $? 1
  761. mariaDBOn=true
  762. else
  763. comprobarError 1 200
  764. fi
  765. # Otras opciones (contraseña)
  766. leerSQLPasswd
  767. }
  768. leerSQLPasswd() {
  769. control=false
  770. error=""
  771. # Leemos la contreseña (stdin) y confirmamos
  772. while [ $control = false ]; do
  773. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  774. comprobarError $? 1
  775. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  776. comprobarError $? 1
  777. #echo -en "SQL Password 1: $sqlPasswd\n"
  778. #echo -en "SQL Password 2: $sqlPasswd2\n"
  779. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  780. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  781. elif [ $sqlPasswd != $sqlPasswd2 ];then
  782. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  783. else
  784. control=true
  785. fi
  786. done
  787. #echo -en "SQL Password: $sqlPasswd\n"
  788. unset control error sqlPasswd2
  789. }
  790. establecerSQLPasswd() {
  791. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  792. # Comprobamos si ya tiene una contraseña asignada
  793. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  794. if [ $? -eq 0 ];then
  795. # Establecemos contraseña del usuario root (y desactivamos posibles plugins para forzar login por contraseña)
  796. mysql -e "UPDATE mysql.user SET plugin = '', Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" >> $logFile 2>&1
  797. comprobarError $? 207
  798. # Desactivamos acceso root desde el exterior (solo localhost)
  799. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" >> $logFile 2>&1
  800. comprobarError $? 208
  801. # Eliminamos todos los usuarios anónimos
  802. mysql -e "DELETE FROM mysql.user WHERE User=''" >> $logFile 2>&1
  803. comprobarError $? 209
  804. # Eliminamos bases de datos 'test'
  805. mysql -e "DROP DATABASE IF EXISTS test" >> $logFile 2>&1
  806. comprobarError $? 210
  807. # Eliminamos privilegios de la base de datos 'test'
  808. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" >> $logFile 2>&1
  809. comprobarError $? 211
  810. # Aplicamos los cambios
  811. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  812. comprobarError $? 212
  813. else
  814. comprobarError 1 206
  815. fi
  816. }
  817. instalarMySQL() {
  818. sqlServerName="mysql"
  819. if [ $debianOS = true ];then
  820. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  821. comprobarError $? 201 $result
  822. elif [ $rhelOS = true ];then
  823. # MySQL no disponible en RHEL. 2 opciones:
  824. # 1) Instalar un repositorio adicional
  825. # 2) No instalar MySQL en distribuciones RHEL
  826. comprobarError 1 205
  827. else
  828. comprobarError 1 203
  829. fi
  830. }
  831. instalarMariaDB() {
  832. sqlServerName="mariadb"
  833. if [ $debianOS = true ];then
  834. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  835. comprobarError $? 202 $result
  836. elif [ $rhelOS = true ];then
  837. result=$(yum -y install mariadb-server mariadb 2>&1)
  838. comprobarError $? 202 $result
  839. else
  840. comprobarError 1 204
  841. fi
  842. }
  843. instalarPHP() {
  844. # Instalamos PHP-7 de forma diferente si es junto a Apache o con Nginx
  845. if [ $debianOS = true ];then
  846. if [ $apacheOn = true ]; then
  847. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-xml php-apcu php-gd 2>&1)
  848. comprobarError $? 302 $result
  849. elif [ $nginxOn = true ];then
  850. phpFPMName="php7.2-fpm"
  851. result=$(apt-get -q -y install php-fpm php-mysql php-intl php-mbstring php-xml php-apcu php-gd 2>&1)
  852. comprobarError $? 302 $result
  853. deshabilitarServicio $phpFPMName
  854. else
  855. comprobarError 1 301
  856. fi
  857. elif [ $rhelOS = true ];then
  858. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  859. result=$(yum -y install epel-release yum-utils 2>&1)
  860. comprobarError $? 103 $result
  861. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  862. if [ ! -f /etc/yum.repos.d/remi-php72.repo ];then
  863. if [ $VERSION = "7" ];then
  864. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-7.rpm 2>&1)
  865. comprobarError $? 303 $result
  866. elif [ $VERSION = "6" ];then
  867. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-6.rpm 2>&1)
  868. comprobarError $? 303 $result
  869. elif [ $VERSION = "28" ];then
  870. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-28.rpm 2>&1)
  871. comprobarError $? 303 $result
  872. elif [ $VERSION = "27" ];then
  873. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-27.rpm 2>&1)
  874. comprobarError $? 303 $result
  875. else
  876. comprobarError 1 304
  877. fi
  878. fi
  879. # Activamos repositorio remi-php72
  880. result=$(yum-config-manager --enable remi-php72 2>&1)
  881. comprobarError $? 303 $result
  882. # Instalamos PHP-7.2
  883. if [ $apacheOn = true ];then
  884. result=$(yum -y install php php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd 2>&1)
  885. comprobarError $? 302 $result
  886. elif [ $nginxOn = true ];then
  887. phpFPMName="php-fpm"
  888. result=$(yum -y install php php-fpm php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd 2>&1)
  889. comprobarError $? 302 $result
  890. deshabilitarServicio $phpFPMName
  891. else
  892. comprobarError 1 301
  893. fi
  894. else
  895. comprobarError 1 300
  896. fi
  897. }
  898. configurarPHP() {
  899. # Configura PHP para segurizarlo y establecer máximo de subida.
  900. if [ $debianOS = true ];then
  901. phpConfFile="./etc/php/php.ini.debian"
  902. phpDest="/etc/php/7.2/cli/php.ini"
  903. elif [ $rhelOS = true ];then
  904. phpConfFile="./etc/php/php.ini.rhel"
  905. phpDest="/etc/php.ini"
  906. fi
  907. if [ ! -f $phpConfFile ];then
  908. comprobarError 1 4 "$phpConfFile"
  909. fi
  910. # Copiamos configuración
  911. cp -f $phpConfFile $phpDest 2>/dev/null
  912. comprobarError $? 305
  913. # Configuramos cgi.fix_pathinfo
  914. sed -i '/cgi.fix_pathinfo=/c\cgi.fix_pathinfo=0' $phpDest
  915. comprobarError $? 305
  916. # Configuramos post_max_size
  917. sed -i '/post_max_size =/c\post_max_size = '$maxUpload $phpDest
  918. comprobarError $? 305
  919. # Configuramos upload_max_filesize
  920. sed -i '/upload_max_filesize =/c\upload_max_filesize = '$maxUpload $phpDest
  921. comprobarError $? 305
  922. # Configurar php-fpm (sólo en RHEL con Nginx)
  923. if [ $rhelOS = true ] && [ $nginxOn = true ];then
  924. # Configurar Socket UNIX
  925. phpConfFile="./etc/php/php-fpm.d/www.conf"
  926. phpDest="/etc/php-fpm.d/www.conf"
  927. if [ ! -f $phpConfFile ];then
  928. comprobarError $? 4 "$phpConfFile"
  929. fi
  930. cp -f $phpConfFile $phpDest 2>/dev/null
  931. comprobarError $? 305
  932. # Configurar Permisos /var/lib/php
  933. chown -R $webServerUser:$webServerGroup /var/lib/php/
  934. comprobarError $? 305
  935. fi
  936. unset phpConfFile phpDest
  937. }
  938. establecerMaxUpload() {
  939. control=false
  940. error=""
  941. while [ $control = false ];do
  942. maxUpload2=$(whiptail --title "PHP MAX UPLOAD" --inputbox "$error""Introduzca el tamaño máximo permitido de los ficheros subidos al servidor:\n(<K:Kilobyte> <M:Megabyte> <G:Gigabyte>)" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) $maxUpload --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  943. comprobarError $? 1
  944. if [ -z $maxUpload2 ];then
  945. error="ERROR: NO PUEDES DEJAR ESTE PARÁMETRO VACIO.\n"
  946. else
  947. control=true
  948. fi
  949. done
  950. maxUpload=$maxUpload2
  951. unset control maxUpload2
  952. }
  953. instalarPHPInfo() {
  954. # Instalar fichero php
  955. if [ ! -f /etc/$webServerName/sites-enabled/phpinfo.conf ];then
  956. infoFile="./var/www/info.php"
  957. if [ ! -f $infoFile ];then
  958. comprobarError 1 4 "$infoFile"
  959. fi
  960. cp -f $infoFile /var/www/html/ 2>/dev/null
  961. comprobarError $? 106
  962. chown -R $webServerUser:$webServerGroup /var/www/html 2>/dev/null
  963. comprobarError $? 106
  964. unset infoFile
  965. # Instalar VirtualHost
  966. if [ $debianOS = true ];then
  967. virtualHost="./etc/$webServerName-debian/sites-available/phpinfo.conf"
  968. elif [ $rhelOS = true ];then
  969. virtualHost="./etc/$webServerName-rhel/sites-available/phpinfo.conf"
  970. fi
  971. instalarVirtualHost $virtualHost
  972. unset virtualHost
  973. return 0
  974. else
  975. return 1
  976. fi
  977. }
  978. habilitarServicio() {
  979. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  980. # Intentamos con systemctl (SystemD)
  981. #echo -en "Habilitando Servicio '$1'" | tee -a $logFile
  982. if [ $# -le 0 ];then
  983. comprobarError 1 900
  984. fi
  985. which systemctl > /dev/null 2>&1
  986. if [ $? -eq 0 ]; then
  987. #echo -en " (SystemD)..." | tee -a $logFile
  988. systemctl start $1 > /dev/null 2>&1
  989. comprobarError $? 901 $1
  990. systemctl enable $1 > /dev/null 2>&1
  991. comprobarError $? 902 $1
  992. else
  993. # Intentamos con service (Upstart)
  994. which service > /dev/null 2>&1
  995. if [ $? -eq 0 ]; then
  996. #echo -en " (Upstart)..." | tee -a $logFile
  997. service $1 start > /dev/null 2>&1
  998. comprobarError $? 901 $1
  999. else
  1000. # Intentamos con init.d (SystemV)
  1001. #echo -en " (SystemV)..." | tee -a $logFile
  1002. /etc/init.d/$1 start > /dev/null 2>&1
  1003. comprobarError $? 901 $1
  1004. fi
  1005. # Intentamos habilitar en el arranque (Upstart)
  1006. which update-rc.d > /dev/null 2>&1
  1007. if [ $? -eq 0 ];then
  1008. update-rc.d $1 enable
  1009. comprobarError $? 902 $1
  1010. else
  1011. # Intentamos habilitar en el arranque (SystemV)
  1012. which chkconfig > /dev/null 2>&1
  1013. if [ $? -eq 0 ];then
  1014. chkconfig $1 on
  1015. comprobarError $? 902 $1
  1016. else
  1017. # ¿Qué mas opciones nos quedan?
  1018. comprobarError 1 902 $1
  1019. fi
  1020. fi
  1021. fi
  1022. # Mejora: comprobar si el servicio está parado
  1023. #echo -en " OK.\n" | tee -a $logFile
  1024. }
  1025. deshabilitarServicio() {
  1026. # Paramos y deshabilitamos el servicio (con SystemD, Upstart o SystemV)
  1027. # Intentamos con systemctl (SystemD)
  1028. #echo -en "Deshabilitando Servicio '$1'" | tee -a $logFile
  1029. if [ $# -le 0 ];then
  1030. comprobarError 1 903
  1031. fi
  1032. which systemctl > /dev/null 2>&1
  1033. if [ $? -eq 0 ]; then
  1034. #echo -en " (SystemD)..." | tee -a $logFile
  1035. systemctl stop $1 > /dev/null 2>&1
  1036. comprobarError $? 904 $1
  1037. systemctl disable $1 > /dev/null 2>&1
  1038. comprobarError $? 905 $1
  1039. else
  1040. # Intentamos con service (Upstart)
  1041. which service > /dev/null 2>&1
  1042. if [ $? -eq 0 ]; then
  1043. #echo -en " (Upstart)..." | tee -a $logFile
  1044. service $1 stop > /dev/null 2>&1
  1045. comprobarError $? 904 $1
  1046. else
  1047. # Intentamos con init.d (SystemV)
  1048. #echo -en " (SystemV)..." | tee -a $logFile
  1049. /etc/init.d/$1 stop > /dev/null 2>&1
  1050. comprobarError $? 904 $1
  1051. fi
  1052. # Intentamos habilitar en el arranque (Upstart)
  1053. which update-rc.d > /dev/null 2>&1
  1054. if [ $? -eq 0 ];then
  1055. update-rc.d $1 disable
  1056. comprobarError $? 905 $1
  1057. else
  1058. # Intentamos habilitar en el arranque (SystemV)
  1059. which chkconfig > /dev/null 2>&1
  1060. if [ $? -eq 0 ];then
  1061. chkconfig $1 off
  1062. comprobarError $? 905 $1
  1063. else
  1064. # ¿Qué mas opciones nos quedan?
  1065. comprobarError 1 905 $1
  1066. fi
  1067. fi
  1068. fi
  1069. # Mejora: comprobar si el servicio está funcionando
  1070. #echo -en " OK.\n" | tee -a $logFile
  1071. }
  1072. recargarServicio() {
  1073. # Recargamos el servicio (con SystemD, Upstart o SystemV)
  1074. # Intentamos con systemctl (SystemD)
  1075. #echo -en "Recargando Servicio '$1'" | tee -a $logFile
  1076. if [ $# -le 0 ];then
  1077. comprobarError 1 912
  1078. fi
  1079. which systemctl > /dev/null 2>&1
  1080. if [ $? -eq 0 ]; then
  1081. #echo -en " (SystemD)..." | tee -a $logFile
  1082. systemctl reload $1 > /dev/null 2>&1
  1083. comprobarError $? 913 $1
  1084. else
  1085. # Intentamos con service (Upstart)
  1086. which service > /dev/null 2>&1
  1087. if [ $? -eq 0 ]; then
  1088. #echo -en " (Upstart)..." | tee -a $logFile
  1089. service $1 reload > /dev/null 2>&1
  1090. comprobarError $? 913 $1
  1091. else
  1092. # Intentamos con init.d (SystemV)
  1093. #echo -en " (SystemV)..." | tee -a $logFile
  1094. /etc/init.d/$1 reload > /dev/null 2>&1
  1095. comprobarError $? 913 $1
  1096. fi
  1097. fi
  1098. # Mejora: comprobar si el servicio está funcionando
  1099. #echo -en " OK.\n" | tee -a $logFile
  1100. }
  1101. configurarCortafuegos() {
  1102. # Configuramos cortafuegos (añadir reglas y encender)
  1103. # Comprobamos si estamos usando SSH
  1104. esSSH $PPID
  1105. if [ $debianOS = true ];then
  1106. ufw allow 80/tcp >> $logFile 2>&1
  1107. comprobarError $? 906 "80/tcp"
  1108. if [ $sshControl = true ];then
  1109. ufw allow 22/tcp >> $logFile 2>&1
  1110. comprobarError $? 906 "22/tcp"
  1111. fi
  1112. if [ $sslOn = true ];then
  1113. ufw allow 443/tcp >> $logFile 2>&1
  1114. comprobarError $? 906 "443/tcp"
  1115. fi
  1116. ufw --force enable >> $logFile 2>&1
  1117. comprobarError $? 907
  1118. elif [ $rhelOS = true ];then
  1119. firewall-cmd --add-port=80/tcp >> $logFile 2>&1
  1120. comprobarError $? 906 "80/tcp"
  1121. if [ $sshControl = true ];then
  1122. firewall-cmd --add-port=22/tcp >> $logFile 2>&1
  1123. comprobarError $? 906 "22/tcp"
  1124. fi
  1125. if [ $sslOn = true ];then
  1126. firewall-cmd --add-port=443/tcp >> $logFile 2>&1
  1127. comprobarError $? 906 "443/tcp"
  1128. fi
  1129. firewall-cmd --runtime-to-permanent >> $logFile 2>&1
  1130. comprobarError $? 907
  1131. habilitarServicio firewalld >> $logFile 2>&1
  1132. comprobarError $? 907
  1133. fi
  1134. unset sshControl
  1135. }
  1136. esSSH() {
  1137. p=${1:-$PPID}
  1138. #read pid name x ppid y < <( cat /proc/$p/stat )
  1139. read pid name ppid < <( ps -o pid= -o comm= -o ppid= -p $p)
  1140. [[ "$name" =~ sshd ]] && { sshControl=true; return 0; }
  1141. [ "$ppid" -le 1 ] && { sshControl=false; return 1; }
  1142. esSSH $ppid
  1143. }
  1144. descargarMediaWiki() {
  1145. # Descargar la versión 1.31.0 de MediaWiki
  1146. if [ ! -d ./var ];then
  1147. comprobarError 1 5 "./var"
  1148. fi
  1149. #echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
  1150. #curl -o "./var/mediawiki-1.31.0.tar.gz" "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" >> $logFile 2>&1
  1151. curl "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" 2>$logFile | tar -xz -C "./var/"
  1152. comprobarError $? 501
  1153. #echo -en " Ok.\n" | tee -a $logFile
  1154. }
  1155. configurarMediaWiki() {
  1156. # Configuramos MediaWiki
  1157. # Copiamos archivos y permisos
  1158. cp -R ./var/mediawiki-1.31.0/ /var/www/$dominioMediaWiki
  1159. comprobarError $? 502
  1160. chown -R $webServerUser:$webServerGroup /var/www/$dominioMediaWiki
  1161. comprobarError $? 502
  1162. # Creamos DataBase
  1163. crearDBMediaWiki
  1164. # Configuramos LocalSettings.php
  1165. # Configuramos VirtualHost
  1166. if [ $nginxOn = true ];then
  1167. if [ $debianOS = true ] && [ $sslOn = false ]; then
  1168. virtualHost="./etc/nginx-debian/sites-available/mediawiki.conf"
  1169. elif [ $debianOS = true ] && [ $sslOn = true ]; then
  1170. virtualHost="./etc/nginx-debian/sites-available/mediawiki-ssl.conf"
  1171. elif [ $rhelOS = true ] && [ $sslOn = false ]; then
  1172. virtualHost="./etc/nginx-rhel/sites-available/mediawiki.conf"
  1173. elif [ $rhelOS = true ] && [ $sslOn = true ]; then
  1174. virtualHost="./etc/nginx-rhel/sites-available/mediawiki-ssl.conf"
  1175. fi
  1176. if [ ! -f $virtualHost ];then
  1177. comprobarError $? 502
  1178. fi
  1179. # Configuramos root, dominio, logs y php-fpm.sock
  1180. sed -i '/root/c\\troot '/var/www/$dominioMediaWiki';' $virtualHost
  1181. comprobarError $? 502
  1182. sed -i '/server_name/c\\tserver_name '$dominioMediaWiki';' $virtualHost
  1183. comprobarError $? 502
  1184. sed -i '/access_log/c\\taccess_log /var/log/nginx/'$dominioMediaWiki'-access.log;' $virtualHost
  1185. comprobarError $? 502
  1186. sed -i '/error_log/c\\terror_log /var/log/nginx/'$dominioMediaWiki'-error.log;' $virtualHost
  1187. comprobarError $? 502
  1188. socket=$(find /var/run/ -type s -name 'php*.sock')
  1189. sed -i '/fastcgi_pass/c\\t\tfastcgi_pass unix:'$socket';' $virtualHost
  1190. comprobarError $? 502
  1191. fi
  1192. instalarVirtualHost $virtualHost $dominioMediWiki
  1193. unset virtualHost socket
  1194. }
  1195. crearDBMediaWiki() {
  1196. # Creamos una base de datos para MediaWiki
  1197. dbDir="./etc/db"
  1198. if [ ! -d $dbDir ];then
  1199. mkdir $dbDir 2>/dev/null
  1200. comprobarError $? 503
  1201. fi
  1202. dbFile=$dbDir"/mediawiki.sql"
  1203. nombreDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1204. userDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1205. echo -en "CREATE DATABASE IF NOT EXISTS $nombreDBMW;\n" > $dbFile
  1206. echo -en "GRANT ALL PRIVILEGES ON $nombreDBMW.* TO '$userDBMW'@'localhost' IDENTIFIED BY '$sqlPasswd';\n" >> $dbFile
  1207. mysql -u root --password=$sqlPasswd < $dbFile
  1208. control=$?
  1209. rm -f $dbFile 2>/dev/null
  1210. comprobarError $? 503
  1211. comprobarError $control 503
  1212. unset control
  1213. }
  1214. descargarMoodle() {
  1215. # Descargar la versión 1.31.0 de MediaWiki
  1216. if [ ! -d ./var ];then
  1217. comprobarError 1 5 "./var"
  1218. fi
  1219. #echo -en "Descargando Moodle-3.5-1..." | tee -a $logFile
  1220. #curl -o "./var/moodle-3.5.1.tgz" "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" >> $logFile 2>&1
  1221. curl "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" 2>$logFile | tar -xz -C "./var/"
  1222. comprobarError $? 501
  1223. #echo -en " OK.\n" | tee -a $logFile
  1224. }
  1225. # Comprobación del sistema e inicialización
  1226. inicializarVariables
  1227. comprobarRoot
  1228. OSInfo
  1229. comprobarDependencias
  1230. # Bienvenida
  1231. mostrarBienvenida
  1232. # Selección de componentes (express vs avanzada)
  1233. mostrarExpress
  1234. # Instalación Servidor Web
  1235. if [ $apacheOn = true ]; then
  1236. echo -en "Instalando Servidor Web Apache..." | tee -a $logFile
  1237. # {
  1238. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1239. instalarApache
  1240. progreso=$((progreso + 1))
  1241. # } > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1242. echo -en " OK.\n" | tee -a $logFile
  1243. elif [ $nginxOn = true ]; then
  1244. echo -en "Instalando Servidor Web Nginx..." | tee -a $logFile
  1245. # {
  1246. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1247. instalarNginx
  1248. progreso=$((progreso + 1))
  1249. # } > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1250. echo -en " OK.\n" | tee -a $logFile
  1251. fi
  1252. # Instalación Base de Datos
  1253. if [ $mySQLOn = true ]; then
  1254. echo -en "Instalando Base de Datos MySQL..." | tee -a $logFile
  1255. # {
  1256. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1257. instalarMySQL
  1258. progreso=$((progreso + 1))
  1259. # } > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1260. echo -en " OK.\n" | tee -a $logFile
  1261. elif [ $mariaDBOn = true ]; then
  1262. echo -en "Instalando Base de Datos MariaDB..." | tee -a $logFile
  1263. # {
  1264. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1265. instalarMariaDB
  1266. progreso=$((progreso + 1))
  1267. # } > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1268. echo -en " OK.\n" | tee -a $logFile
  1269. fi
  1270. # Instalación PHP-7.2
  1271. if [ $phpOn = true ]; then
  1272. echo -en "Instalando PHP-7..." | tee -a $logFile
  1273. # {
  1274. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1275. instalarPHP
  1276. progreso=$((progreso + 1))
  1277. # } > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1278. echo -en " OK.\n" | tee -a $logFile
  1279. fi
  1280. # Instalación SSL/TLS
  1281. if [ $sslOn = true ];then
  1282. echo -en "Instalando SSL/TLS..." | tee -a $logfile
  1283. # {
  1284. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1285. sleep 2
  1286. progreso=$((progreso + 1))
  1287. # } > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1288. echo -en " OK.\n" | tee -a $logFile
  1289. fi
  1290. # Configuración Web Server
  1291. if [ $apacheOn = true ];then
  1292. echo -en "Configurando Servidor Web Apache..." | tee -a $logFile
  1293. # {
  1294. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1295. configurarApache
  1296. progreso=$((progreso + 1))
  1297. # } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1298. echo -en " OK.\n" | tee -a $logFile
  1299. elif [ $nginxOn = true ]; then
  1300. echo -en "Configurando Servidor Web Nginx..." | tee -a $logFile
  1301. # {
  1302. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1303. configurarNginx
  1304. progreso=$((progreso + 1))
  1305. # } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1306. echo -en " OK.\n" | tee -a $logFile
  1307. fi
  1308. # Configuración Database (Arrancar Base de Datos, establecer contraseña y configuración segura)
  1309. if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
  1310. habilitarServicio "$sqlServerName"
  1311. echo -en "Configurando Base de Datos MySQL..." | tee -a $logFile
  1312. # {
  1313. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1314. establecerSQLPasswd
  1315. progreso=$((progreso + 1))
  1316. # } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1317. echo -en " OK.\n" | tee -a $logFile
  1318. fi
  1319. # Configuración PHP (cgi.fix_pathinfo=0 y Configurar máximo de subida de archivos)
  1320. if [ $phpOn = true ];then
  1321. echo -en "Configurando PHP-7..." | tee -a $logFile
  1322. # {
  1323. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1324. configurarPHP
  1325. progreso=$((progreso + 1))
  1326. # } > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1327. echo -en " OK.\n" | tee -a $logFile
  1328. fi
  1329. # Configuración SSL/TLS
  1330. # Generar certificados
  1331. # Configurar certificados
  1332. if [ $sslOn = true ];then
  1333. echo -en "Configurando SSL/TLS..." | tee -a $logFile
  1334. # {
  1335. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1336. sleep 2
  1337. progreso=$((progreso + 1))
  1338. # } > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1339. echo -en " OK.\n" | tee -a $logFile
  1340. fi
  1341. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  1342. # {
  1343. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1344. if [ $apacheOn = true ];then
  1345. habilitarServicio $webServerName
  1346. elif [ $nginxOn = true ];then
  1347. habilitarServicio $webServerName
  1348. if [ $phpOn = true ];then
  1349. habilitarServicio $phpFPMName
  1350. fi
  1351. fi
  1352. progreso=$((progreso + 1))
  1353. # } > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1354. # MediaWiki
  1355. if [ $mediaWikiOn = true ]; then
  1356. # Descargar MediaWiki
  1357. echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
  1358. # {
  1359. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1360. descargarMediaWiki
  1361. progreso=$((progreso + 1))
  1362. # } > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1363. echo -en " OK.\n" | tee -a $logFile
  1364. # Configurar MediWiki
  1365. echo -en "Configurando MediaWiki..." | tee -a $logFile
  1366. # {
  1367. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1368. configurarMediaWiki
  1369. progreso=$((progreso + 1))
  1370. # } > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1371. echo -en " OK.\n" | tee -a $logFile
  1372. fi
  1373. # Moodle
  1374. if [ $moodleOn = true ]; then
  1375. # Descargar Moodle
  1376. echo -en "Descargando Moodle-3.5.1..." | tee -a $logFile
  1377. # {
  1378. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1379. descargarMoodle
  1380. progreso=$((progreso + 1))
  1381. # } > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1382. echo -en " OK.\n" | tee -a $logFile
  1383. # Configuración Moodle
  1384. echo -en "Configurando Moodle..." | tee -a $logFile
  1385. # {
  1386. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1387. sleep 2
  1388. progreso=$((progreso + 1))
  1389. # } > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1390. echo -en " OK.\n" | tee -a $logFile
  1391. fi
  1392. # Configurar Virtual Hosts
  1393. # Instalar info.php
  1394. if [ $infoPHPOn = true ];then
  1395. echo -en "Configurando 'info.php'..." | tee -a $logFile
  1396. instalarPHPInfo
  1397. if [ $? -eq 0 ];then
  1398. echo -en " OK.\n" | tee -a $logFile
  1399. else
  1400. echo -en " Ya se encuentra configurado.\n" | tee -a $logFile
  1401. fi
  1402. fi
  1403. # Añadir reglas del cortafuegos
  1404. echo -en "Configurando Cortafuegos..." | tee -a $logFile
  1405. # {
  1406. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1407. configurarCortafuegos
  1408. progreso=$((progreso + 1))
  1409. # } > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1410. echo -en " OK.\n" | tee -a $logFile
  1411. # Configurar actualizaciones
  1412. if [ $actualizacionesOn = true ]; then
  1413. echo -en "Configurando Actualizaciones Automáticas..." | tee -a $logFile
  1414. # {
  1415. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1416. sleep 2
  1417. progreso=$((progreso + 1))
  1418. # } > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1419. echo -en " OK.\n" | tee -a $logFile
  1420. fi